pop_size = 50;
ind_length = 100;
mutation_rate = 0.0250;
time_out = 20000;
global max_fit = 0, Debug = 0;
global goal_fitness = 100;
global goal_pattern = mod((1:ind_length), 2);

%----------------- functions ------------------------

global bin_list = inline( "rand( 1, len ) < thresh" );

mutate   = inline( "xor( indiv, bin_list( size( indiv, 2 ), mutation_rate ) )" );

function f = baby_fitness(x)
	global max_fit;
	global calls = 0;
	f = sum(x);
	max_fit = max(max_fit, f);
	disp(sprintf("%g %g", ++calls, f));
end

function [ c1, c2 ] = xover( p1, p2 )
	global bin_list;
	mask = bin_list( size( p1, 2 ), 0.5 );
	c1 = (mask & p1) | ((!mask) & p2);
	c2 = (mask & p2) | ((!mask) & p1);
end

%----------------- main program ------------------------

pop = zeros( pop_size, ind_length );
fit = zeros( pop_size, 1 );

for iteration = 1 : time_out
	ix = randperm(pop_size); 
	p1 = ix(1); p2 = ix(2); c1 = ix(3); c2 = ix(4);

	if (fit(c1) > fit(p1)) temp = c1; c1 = p1; p1 = temp; end
	if (fit(c2) > fit(p2)) temp = c2; c2 = p2; p2 = temp; end

	[child1,child2] = xover( pop(p1,:), pop(p2,:) );

	pop(c1,:) = mutate(child1, mutation_rate);
	pop(c2,:) = mutate(child2, mutation_rate);

	fit(c1) = baby_fitness(pop(c1,:));
	fit(c2) = baby_fitness(pop(c2,:));

	if max_fit >= goal_fitness ; break; end
end
